var _templateObject = _taggedTemplateLiteral(['\n  margin-bottom: ', ';\n  font-family: ', ';\n\n  font-weight: ', ';\n  line-height: ', ';\n  color: ', ';\n\n  ', ';\n'], ['\n  margin-bottom: ', ';\n  font-family: ', ';\n\n  font-weight: ', ';\n  line-height: ', ';\n  color: ', ';\n\n  ', ';\n']);

function _taggedTemplateLiteral(strings, raw) { return Object.freeze(Object.defineProperties(strings, { raw: { value: Object.freeze(raw) } })); }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import { createElement } from 'react';
import PropTypes from 'prop-types';
import styled from 'styled-components';

import omit from 'lodash.omit';

var Element = function Element(_ref) {
  var as = _ref.as,
      children = _ref.children,
      props = _objectWithoutProperties(_ref, ['as', 'children']);

  return createElement(as, omit(props, ['as', 'size']), children);
};

var Heading = styled(Element)(_templateObject, function (props) {
  return props.theme.headingsMarginBottom;
}, function (props) {
  return props.theme.headingsFontFamily;
}, function (props) {
  return props.theme.headingsFontWeight;
}, function (props) {
  return props.theme.headingsLineHeight;
}, function (props) {
  return props.theme.headingsColor;
}, function (props) {
  var size = props.size || props.as;

  switch (size) {
    case 'h1':
      return 'font-size: ' + props.theme.h1FontSize + ';';
    case 'h2':
      return 'font-size: ' + props.theme.h2FontSize + ';';
    case 'h3':
      return 'font-size: ' + props.theme.h3FontSize + ';';
    case 'h4':
      return 'font-size: ' + props.theme.h4FontSize + ';';
    case 'h5':
      return 'font-size: ' + props.theme.h5FontSize + ';';
    case 'h6':
      return 'font-size: ' + props.theme.h6FontSize + ';';
    default:
      return 'font-size: ' + props.theme.fontSizeBase + ';';
  }
});

Heading.defaultProps = {
  as: 'h1'
};

Heading.proptypes = {
  as: PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'span', 'p']),
  size: PropTypes.oneOf(['h1', 'h2', 'h3', 'h4', 'h5', 'h6'])
};

export default Heading;